%define		tag	RELEASE.2017-01-25T03-14-52Z
%define		subver	%(echo %{tag} | sed -e 's/[^0-9]//g')
# git fetch https://github.com/minio/minio.git refs/tags/RELEASE.2017-01-25T03-14-52Z
# git rev-list -n 1 FETCH_HEAD
%define		commitid	f8e4700a11065967242b8857045ce7dee607722d
Summary:	Object Storage Server
Name:		minio
Version:	0.0.%{subver}
Release:	1
License:	Apache v2.0
Group:		Development/Building
Source0:	https://github.com/minio/minio/archive/%{tag}.tar.gz
# Source0-md5:	0c3a765963ce20b5436c54c5f52984d5
URL:		https://www.minio.io/
BuildRequires:	golang >= 1.7
ExclusiveArch:	%{ix86} %{x8664} %{arm}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# go stuff
%define		_enable_debug_packages 0
%define		gobuild(o:) go build -ldflags "${LDFLAGS:-} -B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \\n')" -a -v -x %{?**};
%define		gopath		%{_libdir}/golang
%define		import_path	github.com/minio/minio

%description
Minio is an object storage server released under Apache License v2.0.
It API compatible with Amazon S3 cloud storage service.

%prep
%setup -qc
mv %{name}-*/* .

install -d src/$(dirname %{import_path})
ln -s ../../.. src/%{import_path}

%build
export GOPATH=$(pwd)
export GOROOT=%{_libdir}/golang

# setup flags like 'go run buildscripts/gen-ldflags.go' would do
tag=%{tag}
version=${tag#RELEASE.}
commitid=%{commitid}
scommitid=$(echo $commitid | cut -c1-12)
prefix=%{import_path}/cmd

LDFLAGS="
-X $prefix.Version=$version
-X $prefix.ReleaseTag=$tag
-X $prefix.CommitID=$commitid
-X $prefix.ShortCommitID=$scommitid
"

%gobuild -o %{name}

# check that version set properly
./%{name} version | tee v

#Version: 2016-09-11T17-42-18Z
#Release-Tag: RELEASE.2016-09-11T17-42-18Z
#Commit-ID: 85e2d886bcb005d49f3876d6849a2b5a55e03cd3
v=$(awk '/Version:/{print $2}' v)
test "$v" = $version
v=$(awk '/Release-Tag:/{print $2}' v)
test "$v" = $tag
v=$(awk '/Commit-ID:/{print $2}' v)
test "$v" = $commitid

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_sbindir}
install -p %{name} $RPM_BUILD_ROOT%{_sbindir}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc *.md
%attr(755,root,root) %{_sbindir}/minio
%changelog
* Wed Jan 25 2017 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/minio.git;a=log;h=master

* Wed Jan 25 2017 Harshavardhana <harsha@minio.io> 497c8e6
- minio: update to 2017-01-25T03-14-52Z release. (#4)

* Tue Dec 13 2016 Harshavardhana <harsha@minio.io> 0d18896
- minio: update to 2016-12-13T17-19-42Z release. (#3)

* Mon Nov 28 2016 Harshavardhana <harsha@minio.io> 9748ba0
- minio: update RELEASE.2016-11-26T02-23-47Z release. resolves #2

* Tue Oct 25 2016 Harshavardhana <harsha@minio.io> e51a1b9
- minio: update to 2016-10-24T21-23-47Z release.

* Thu Sep 22 2016 Elan Ruusamäe <glen@delfi.ee> e846e37
- use 0.0 as version base

* Thu Sep 22 2016 Elan Ruusamäe <glen@delfi.ee> c308e72
- setup version to binary like upstream does

* Thu Sep 22 2016 Elan Ruusamäe <glen@delfi.ee> bbc8094
- up to RELEASE.2016-09-11T17-42-18Z, builds now

* Wed Apr 06 2016 Elan Ruusamäe <glen@delfi.ee> 38464fd
- new, version 1.1.0

